//+------------------------------------------------------------------+
//|                                                 CCI Ma cross.mq4 |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  DodgerBlue
#property indicator_color2  Red

//
//
//
//
//

extern int    CciPeriod        = 50;
extern int    CciPrice         = PRICE_TYPICAL;
extern int    MaPeriod         = 14;
extern int    MaType           = MODE_EMA;
extern int    arrowSize        = 2;

extern string note             = "turn on Alert = true; turn off = false";
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = true;
extern bool   alertsEmail      = false;
extern bool   alertsNotify     = false;
extern string soundfile        = "alert2.wav";

//
//
//
//
//

double CrossUp[];
double CrossDn[];
double cci[];
double ccima[];
double prices[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
      SetIndexBuffer(0,CrossUp); SetIndexStyle(0,DRAW_ARROW,0,arrowSize); SetIndexArrow(0,241);
      SetIndexBuffer(1,CrossDn); SetIndexStyle(1,DRAW_ARROW,0,arrowSize); SetIndexArrow(1,242);
      SetIndexBuffer(2,cci);
      SetIndexBuffer(3,ccima); 
      SetIndexBuffer(4,prices);
      SetIndexBuffer(5,trend);
   IndicatorShortName("Cci ("+CciPeriod+","+MaPeriod+")");
return(0);
}

int deinit()
{
   
return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,k,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
      prices[i]  = iMA(NULL,0,1,0,MODE_SMA,CciPrice,i);
      double avg = 0; for(k=0; k<CciPeriod; k++) avg +=         prices[i+k];      avg /= CciPeriod;
      double dev = 0; for(k=0; k<CciPeriod; k++) dev += MathAbs(prices[i+k]-avg); dev /= CciPeriod;
         if (dev!=0)
               cci[i] = (prices[i]-avg)/(0.015*dev);
         else  cci[i] = 0;          
   }
   
   for (i=limit; i>=0; i--)
   {
      ccima[i] = iMAOnArray(cci,0,MaPeriod,0,MaType,i);
      trend[i] = trend[i+1];
         if (cci[i]>ccima[i]) trend[i] = 1;
         if (cci[i]<ccima[i]) trend[i] =-1;
         
         //
         //
         //
         //
         //
         
         CrossUp[i] = EMPTY_VALUE;
         CrossDn[i] = EMPTY_VALUE;
         if (trend[i]!= trend[i+1])
         if (trend[i] == 1)
               CrossUp[i] = Low[i]  - iATR(NULL,0,20,i)/2;
         else  CrossDn[i] = High[i] + iATR(NULL,0,20,i)/2;
         }
          
         //
         //
         //
         //
         //
      
         if (alertsOn)
         {
           if (alertsOnCurrent)
                int whichBar = 0;
           else     whichBar = 1;
           if (trend[whichBar] != trend[whichBar+1])
           if (trend[whichBar] == 1)
                 doAlert("Buy");
           else  doAlert("Sell");       
        }
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Cci Ma Cross ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Cci Ma Cross "),message);
             if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," Cci Ma Cross " +" "+message));
             if (alertsSound)   PlaySound(soundfile);
      }
}


